'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.decorator = exports.plugin = undefined;

var _rxact = require('rxact');

var _createObserver2 = require('./createObserver');

var _createObserver3 = _interopRequireDefault(_createObserver2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var plugin = exports.plugin = function plugin() {
  return function (instance) {
    var _createObserver = (0, _createObserver3.default)(instance.state$),
        decorator = _createObserver.decorator,
        subscription = _createObserver.subscription;

    instance.observer = decorator;
    instance.subscriptions.push(subscription);
  };
};

var decorator = exports.decorator = function decorator() {
  return function (StateStream) {
    return function (_StateStream) {
      _inherits(DebuggableStream, _StateStream);

      function DebuggableStream() {
        var _ref;

        var _this, _ret;

        _classCallCheck(this, DebuggableStream);

        for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
          params[_key] = arguments[_key];
        }

        var instance = (_this = _possibleConstructorReturn(this, (_ref = DebuggableStream.__proto__ || Object.getPrototypeOf(DebuggableStream)).call.apply(_ref, [this].concat(params))), _this);

        return _ret = plugin()(instance), _possibleConstructorReturn(_this, _ret);
      }

      return DebuggableStream;
    }(StateStream);
  };
};